## docker-compose-v2 2.20.2+ds1

=== Makefile ===
#   Copyright 2020 Docker Compose CLI authors

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

PKG := github.com/docker/compose/v2
VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always --tags)

GO_LDFLAGS ?= -w -X ${PKG}/internal.Version=${VERSION}
GO_BUILDTAGS ?= e2e
DRIVE_PREFIX?=
ifeq ($(OS),Windows_NT)
    DETECTED_OS = Windows
    DRIVE_PREFIX=C:
else
    DETECTED_OS = $(shell uname -s)
endif

ifeq ($(DETECTED_OS),Windows)
	BINARY_EXT=.exe
endif

BUILD_FLAGS?=
TEST_FLAGS?=
E2E_TEST?=
ifeq ($(E2E_TEST),)
else
	TEST_FLAGS=-run $(E2E_TEST)
endif

BUILDX_CMD ?= docker buildx

# DESTDIR overrides the output path for binaries and other artifacts
# this is used by docker/docker-ce-packaging for the apt/rpm builds,
# so it's important that the resulting binary ends up EXACTLY at the
# path $DESTDIR/docker-compose when specified.
#
# See https://github.com/docker/docker-ce-packaging/blob/e43fbd37e48fde49d907b9195f23b13537521b94/rpm/SPECS/docker-compose-plugin.spec#L47
#
# By default, all artifacts go to subdirectories under ./bin/ in the
# repo root, e.g. ./bin/build, ./bin/coverage, ./bin/release.
DESTDIR ?=

all: build

.PHONY: build ## Build the compose cli-plugin
build:
	GO111MODULE=on go build $(BUILD_FLAGS) -trimpath -tags "$(GO_BUILDTAGS)" -ldflags "$(GO_LDFLAGS)" -o "$(or $(DESTDIR),./bin/build)/docker-compose$(BINARY_EXT)" ./cmd

.PHONY: binary
binary:
	$(BUILDX_CMD) bake binary

.PHONY: binary-with-coverage
binary-with-coverage:
	$(BUILDX_CMD) bake binary-with-coverage

.PHONY: install
install: binary
	mkdir -p ~/.docker/cli-plugins
	install $(or $(DESTDIR),./bin/build)/docker-compose ~/.docker/cli-plugins/docker-compose

.PHONY: e2e-compose
e2e-compose: ## Run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test
	go test $(TEST_FLAGS) -count=1 ./pkg/e2e

.PHONY: e2e-compose-standalone
e2e-compose-standalone: ## Run End to end local tests in standalone mode. Set E2E_TEST=TestName to run a single test
	go test $(TEST_FLAGS) -v -count=1 -parallel=1 --tags=standalone ./pkg/e2e

.PHONY: test-cucumber
test-cucumber:
	go test $(TEST_FLAGS) -v -count=1 -parallel=1 ./e2e

.PHONY: build-and-e2e-compose
build-and-e2e-compose: build e2e-compose ## Compile the compose cli-plugin and run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test

.PHONY: build-and-e2e-compose-standalone
build-and-e2e-compose-standalone: build e2e-compose-standalone ## Compile the compose cli-plugin and run End to end local tests in standalone mode. Set E2E_TEST=TestName to run a single test

.PHONY: mocks
mocks:
	mockgen --version >/dev/null 2>&1 || go install github.com/golang/mock/mockgen@v1.6.0
	mockgen -destination pkg/mocks/mock_docker_cli.go -package mocks github.com/docker/cli/cli/command Cli
	mockgen -destination pkg/mocks/mock_docker_api.go -package mocks github.com/docker/docker/client APIClient
	mockgen -destination pkg/mocks/mock_docker_compose_api.go -package mocks -source=./pkg/api/api.go Service

.PHONY: e2e
e2e: e2e-compose e2e-compose-standalone ## Run end to end local tests in both modes. Set E2E_TEST=TestName to run a single test

.PHONY: build-and-e2e
build-and-e2e: build e2e-compose e2e-compose-standalone ## Compile the compose cli-plugin and run end to end local tests in both modes. Set E2E_TEST=TestName to run a single test

.PHONY: cross
cross: ## Compile the CLI for linux, darwin and windows
	$(BUILDX_CMD) bake binary-cross

.PHONY: test
test: ## Run unit tests
	$(BUILDX_CMD) bake test

.PHONY: cache-clear
cache-clear: ## Clear the builder cache
	$(BUILDX_CMD) prune --force --filter type=exec.cachemount --filter=unused-for=24h

.PHONY: lint
lint: ## run linter(s)
	$(BUILDX_CMD) bake lint

.PHONY: docs
docs: ## generate documentation
	$(eval $@_TMP_OUT := $(shell mktemp -d -t compose-output.XXXXXXXXXX))
	$(BUILDX_CMD) bake --set "*.output=type=local,dest=$($@_TMP_OUT)" docs-update
	rm -rf ./docs/internal
	cp -R "$(DRIVE_PREFIX)$($@_TMP_OUT)"/out/* ./docs/
	rm -rf "$(DRIVE_PREFIX)$($@_TMP_OUT)"/*

.PHONY: validate-docs
validate-docs: ## validate the doc does not change
	$(BUILDX_CMD) bake docs-validate

.PHONY: check-dependencies
check-dependencies: ## check dependency updates
	go list -u -m -f '{{if not .Indirect}}{{if .Update}}{{.}}{{end}}{{end}}' all

.PHONY: validate-headers
validate-headers: ## Check license header for all files
	$(BUILDX_CMD) bake license-validate

.PHONY: go-mod-tidy
go-mod-tidy: ## Run go mod tidy in a container and output resulting go.mod and go.sum
	$(BUILDX_CMD) bake vendor-update

.PHONY: validate-go-mod
validate-go-mod: ## Validate go.mod and go.sum are up-to-date
	$(BUILDX_CMD) bake vendor-validate

validate: validate-go-mod validate-headers validate-docs  ## Validate sources

pre-commit: validate check-dependencies lint build test e2e-compose

help: ## Show help
	@echo Please specify a build target. The choices are:
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

=== debian/changelog ===
docker-compose-v2 (2.20.2+ds1-0ubuntu1) mantic; urgency=medium

  * Initial release.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 10 Aug 2023 10:17:52 -0300

=== debian/control ===
Source: docker-compose-v2
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               golang-go
Standards-Version: 4.6.2
Homepage: https://github.com/docker/compose
Vcs-Git: https://github.com/canonical/docker-compose-v2.git
Vcs-Browser: https://github.com/canonical/docker-compose-v2
Rules-Requires-Root: no

Package: docker-compose-v2
Architecture: any
Depends: docker.io,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: tool for running multi-container applications on Docker
 Docker Compose is a tool for running multi-container applications on Docker
 defined using the Compose file format. A Compose file is used to define how one
 or more containers that make up your application are configured. Once you have
 a Compose file, you can create and start your application with a single
 command: docker compose up.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
export VERSION := $(DEB_VERSION)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

override_dh_gencontrol:
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker-compose-v2.substvars
	dh_gencontrol

override_dh_auto_build:
	VERSION="$(VERSION)" make build

# Basic smoke test to ensure binary built successfully
# (especially since its actual tests, even unit tests, are *really* involved.
# They depend on docker itself which requires user's permission adjustement or
# running with root. That's just the beginning :)
# Let's smoke test the plugin via autopkgtest. FWIW this is the same thing we
# do with src:docker.io-app.
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./bin/build/docker-compose version
endif

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

override_dh_dwz:
	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
	# dh_dwz --no-dwz-multifile also does not work :)

%:
	dh $@

## docker-compose-v2 2.24.6+ds1

=== Makefile ===
--- 
+++ 
@@ -32,9 +32,13 @@
 BUILD_FLAGS?=
 TEST_FLAGS?=
 E2E_TEST?=
-ifeq ($(E2E_TEST),)
-else
-	TEST_FLAGS=-run $(E2E_TEST)
+ifneq ($(E2E_TEST),)
+	TEST_FLAGS:=$(TEST_FLAGS) -run '$(E2E_TEST)'
+endif
+
+EXCLUDE_E2E_TESTS?=
+ifneq ($(EXCLUDE_E2E_TESTS),)
+	TEST_FLAGS:=$(TEST_FLAGS) -skip '$(EXCLUDE_E2E_TESTS)'
 endif
 
 BUILDX_CMD ?= docker buildx
@@ -71,15 +75,11 @@
 
 .PHONY: e2e-compose
 e2e-compose: ## Run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test
-	go test $(TEST_FLAGS) -count=1 ./pkg/e2e
+	go test -v $(TEST_FLAGS) -count=1 ./pkg/e2e
 
 .PHONY: e2e-compose-standalone
 e2e-compose-standalone: ## Run End to end local tests in standalone mode. Set E2E_TEST=TestName to run a single test
 	go test $(TEST_FLAGS) -v -count=1 -parallel=1 --tags=standalone ./pkg/e2e
-
-.PHONY: test-cucumber
-test-cucumber:
-	go test $(TEST_FLAGS) -v -count=1 -parallel=1 ./e2e
 
 .PHONY: build-and-e2e-compose
 build-and-e2e-compose: build e2e-compose ## Compile the compose cli-plugin and run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test
@@ -89,7 +89,7 @@
 
 .PHONY: mocks
 mocks:
-	mockgen --version >/dev/null 2>&1 || go install github.com/golang/mock/mockgen@v1.6.0
+	mockgen --version >/dev/null 2>&1 || go install go.uber.org/mock/mockgen@v0.3.0
 	mockgen -destination pkg/mocks/mock_docker_cli.go -package mocks github.com/docker/cli/cli/command Cli
 	mockgen -destination pkg/mocks/mock_docker_api.go -package mocks github.com/docker/docker/client APIClient
 	mockgen -destination pkg/mocks/mock_docker_compose_api.go -package mocks -source=./pkg/api/api.go Service

=== debian/changelog ===
docker-compose-v2 (2.24.6+ds1-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport version from Noble to Jammy (LP: #2040460).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 12 Mar 2024 18:08:11 -0300

docker-compose-v2 (2.24.6+ds1-0ubuntu1) noble; urgency=medium

  * New upstream release.
  * d/p/fix-build.patch: refresh against new upstream release.
  * Build with Go 1.21, recommended by upstream.
    - d/control: b-d on golang-1.21-go instead of golang-go.
    - d/rules: add Go 1.21 binary to the $PATH.
  * d/docker-compose-v2.docs: remove NOTICE file from a vendorized dependency
    that was removed.
  * d/copyright: remove superfluous file patterns.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 19 Feb 2024 17:56:31 -0300

docker-compose-v2 (2.20.2+ds1-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport version from Mantic to Jammy (LP: #1968035, #2036350).
    - Build with Go 1.20.
      + d/control: b-d on golang-1.20-go.
      + d/rules: add Go 1.20 to $PATH.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Sun, 17 Sep 2023 09:26:22 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper-compat (= 12),
-               golang-go
+               golang-1.21-go
 Standards-Version: 4.6.2
 Homepage: https://github.com/docker/compose
 Vcs-Git: https://github.com/canonical/docker-compose-v2.git

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 
 # https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
 export GO111MODULE := auto
+
+# Build with Golang 1.21
+export PATH := /usr/lib/go-1.21/bin:$(PATH)
 
 override_dh_gencontrol:
 	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker-compose-v2.substvars

## docker-compose-v2 2.27.1+ds1

=== Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 #   limitations under the License.
 
 PKG := github.com/docker/compose/v2
+export COMPOSE_MENU = FALSE
 VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always --tags)
 
 GO_LDFLAGS ?= -w -X ${PKG}/internal.Version=${VERSION}
@@ -75,11 +76,11 @@
 
 .PHONY: e2e-compose
 e2e-compose: ## Run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test
-	go test -v $(TEST_FLAGS) -count=1 ./pkg/e2e
+	go run gotest.tools/gotestsum@latest --format testname --junitfile "/tmp/report/report.xml" -- -v $(TEST_FLAGS) -count=1 ./pkg/e2e
 
 .PHONY: e2e-compose-standalone
 e2e-compose-standalone: ## Run End to end local tests in standalone mode. Set E2E_TEST=TestName to run a single test
-	go test $(TEST_FLAGS) -v -count=1 -parallel=1 --tags=standalone ./pkg/e2e
+	go run gotest.tools/gotestsum@latest --format testname --junitfile "/tmp/report/report.xml" -- $(TEST_FLAGS) -v -count=1 -parallel=1 --tags=standalone ./pkg/e2e
 
 .PHONY: build-and-e2e-compose
 build-and-e2e-compose: build e2e-compose ## Compile the compose cli-plugin and run end to end local tests in plugin mode. Set E2E_TEST=TestName to run a single test
@@ -89,7 +90,7 @@
 
 .PHONY: mocks
 mocks:
-	mockgen --version >/dev/null 2>&1 || go install go.uber.org/mock/mockgen@v0.3.0
+	mockgen --version >/dev/null 2>&1 || go install go.uber.org/mock/mockgen@v0.4.0
 	mockgen -destination pkg/mocks/mock_docker_cli.go -package mocks github.com/docker/cli/cli/command Cli
 	mockgen -destination pkg/mocks/mock_docker_api.go -package mocks github.com/docker/docker/client APIClient
 	mockgen -destination pkg/mocks/mock_docker_compose_api.go -package mocks -source=./pkg/api/api.go Service

=== debian/changelog ===
docker-compose-v2 (2.27.1+ds1-0ubuntu1~24.04.1) noble; urgency=medium

  * Backport from oracular to noble. (LP: #2040461)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 14 Oct 2024 11:16:52 -0300

docker-compose-v2 (2.27.1+ds1-0ubuntu1) oracular; urgency=medium

  * New upstream release.
  * Refresh patch.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 04 Jun 2024 18:27:26 -0300

docker-compose-v2 (2.24.6+ds1-0ubuntu2) noble; urgency=medium

  * Build with Go 1.22.
    - d/control: b-d on golang-1.22-go instead of golang-1.21-go
    - d/rules: add Go 1.22 to $PATH

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 17 Apr 2024 17:13:40 -0300

## docker-compose-v2 2.33.0+ds1

=== vendor/github.com/r3labs/sse/Makefile ===
install:
	go install -v

build:
	go build -v ./...

lint:
	golint ./...
	go vet ./...

test:
	go test -v ./... --cover

deps:
	go get -u gopkg.in/cenkalti/backoff.v1
	go get -u github.com/golang/lint/golint
	go get -u github.com/stretchr/testify

clean:
	go clean

=== debian/changelog ===
docker-compose-v2 (2.33.0+ds1-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport from plucky to jammy (LP: #2085187)
  * d/control: build with golang 1.22 for consistency across the supported
    release
  * d/rules: add golang 1.22 to PATH
  * d/p/toolchain.patch: set go minimum version to 1.22

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 27 Mar 2025 09:05:03 -0300

docker-compose-v2 (2.33.0+ds1-0ubuntu1) plucky; urgency=medium

  * New upstream version 2.33.0+ds1
  * d/control: build with golang 1.24 (LP: #2098663)
  * d/rules: add golang 1.24 to PATH
  * d/docker-compose-v2.docs: update NOTICE file list
  * d/s/lintian-overrides: remove unused override
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 17 Feb 2025 17:16:24 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper-compat (= 12),
-               golang-1.21-go
+               golang-1.22-go
 Standards-Version: 4.6.2
 Homepage: https://github.com/docker/compose
 Vcs-Git: https://github.com/canonical/docker-compose-v2.git

## docker-compose-v2 2.37.1%2Bds1

=== debian/watch ===
version=4

opts="repack,repacksuffix=+ds1,compression=xz,dversionmangle=s/\+ds1//,filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%docker-compose-v2-$1.tar.gz%,oversionmangle=s/(.*)/$1\+ds1/" \
  https://github.com/docker/compose/tags \
  (?:.*?/)?v(\d[\d.]*)\.tar\.gz \
  debian debian/repack-compose-with-vendor.sh

## docker-compose-v2 2.37.1+ds1

=== debian/changelog ===
docker-compose-v2 (2.37.1+ds1-0ubuntu2~22.04.1) jammy; urgency=medium

  * Backport from questing to jammy (LP: #2112523)
  * d/control: build with golang 1.23
  * d/rules: add golang 1.23 to PATH
  * d/p/toolchain.patch: set go minimum version to 1.23

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 10 Sep 2025 15:55:15 -0300

docker-compose-v2 (2.37.1+ds1-0ubuntu2) questing; urgency=medium

  [ Renan Rodrigo ]
  * d/control: Provide docker-compose

  [ Athos Ribeiro ]
  * d/control: demote docker.io to recommends (LP: #2079929)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 14 Aug 2025 09:27:38 -0300

docker-compose-v2 (2.37.1+ds1-0ubuntu1) questing; urgency=medium

  * New upstream version 2.37.1+ds1
  * d/docker-compose-v2.docs: update NOTICE file list
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 16 Jun 2025 15:11:00 -0300

=== debian/rules ===
--- 
+++ 
@@ -12,8 +12,8 @@
 # https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
 export GO111MODULE := auto
 
-# Build with Golang 1.21
-export PATH := /usr/lib/go-1.21/bin:$(PATH)
+# Build with Golang 1.23
+export PATH := /usr/lib/go-1.23/bin:$(PATH)
 
 override_dh_gencontrol:
 	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker-compose-v2.substvars

=== debian/tests/control ===
Tests: basic-smoke
Depends: @, docker.io, curl
Restrictions: isolation-machine needs-root allow-stderr

## docker-compose-v2 2.40.3+ds1

=== debian/changelog ===
docker-compose-v2 (2.40.3+ds1-0ubuntu1) resolute; urgency=medium

  * New upstream version 2.40.3
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos@ubuntu.com>  Tue, 06 Jan 2026 11:22:58 -0300
